> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Replace Offsite Audiences Job

> Replace the contents of an existing offsite audience. This endpoint returns a new job id and presigned url for uploading the replacement audience CSV.



## OpenAPI

````yaml /openapi.json put /public/v1/offsite-ads/audiences/{audience-id}
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
paths:
  /public/v1/offsite-ads/audiences/{audience-id}:
    put:
      tags:
        - Offsite Ads API
      summary: Replace Offsite Audiences Job
      description: >-
        Replace the contents of an existing offsite audience. This endpoint
        returns a new job id and presigned url for uploading the replacement
        audience CSV.
      operationId: replace_offsite_audience_contents
      parameters:
        - name: audience-id
          in: path
          required: true
          schema:
            type: string
            description: The audience ID to replace.
          description: The audience ID to replace.
      requestBody:
        content:
          application/json:
            schema:
              title: Body
              oneOf:
                - $ref: >-
                    #/components/schemas/Advanced_APIs_PublicOffsiteAudienceReplaceRequest
                - type: 'null'
      responses:
        '202':
          description: Accepted
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Advanced_APIs_PublicOffsiteAudienceCreateResponse
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_PublicOffsiteAudienceReplaceRequest:
      properties:
        name:
          title: Name
          description: Optional updated name of the user list audience.
          examples:
            - My user list audience
          oneOf:
            - type: string
              minLength: 1
            - type: 'null'
        description:
          title: Description
          description: Optional updated description of the user list audience.
          examples:
            - This is a user list audience description.
          oneOf:
            - type: string
              minLength: 1
            - type: 'null'
      type: object
      title: PublicOffsiteAudienceReplaceRequest
    Advanced_APIs_PublicOffsiteAudienceCreateResponse:
      properties:
        jobId:
          type: string
          format: uuid
          title: Jobid
          description: The unique identifier for the queued job.
          examples:
            - 123e4567-e89b-12d3-a456-426614174000
        url:
          type: string
          title: Url
          description: |-
            The presigned url to upload the audience csv file.
                    Presigned url must be used with PUT method and include the header `Content-Type: text/csv`.
          examples:
            - >-
              https://offsite-ads-user-list-uploads.s3.us-east-2.amazonaws.com/123e4567-e89b-12d3-a456-426614174000.csv
      type: object
      required:
        - jobId
        - url
      title: PublicOffsiteAudienceCreateResponse
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````